import java.util.ArrayDeque;
import java.util.Deque;

/**
 * В данной программе мы демонстрируем использование класса ArrayDeque.
 * Мы реализовали операцию сложения двух натуральных чисел сколь угодно большой длины с одним ограничением: числа должны быть одной длины.
 * */

public class Main {
    public static void main(String[] args) {
        /*Первое число*/
        String a = "0123456789";
        /*Второе число*/
        String b = "3745983475";

        /*Заводим дек*/
        Deque<Integer> q = new ArrayDeque<>();
        /*Переменная для запоминания разряда*/
        int ostatok = 0;
        /*Будем двигаться с конца чисел к началу*/
        for (int i = a.length() - 1; i >= 0; --i) {
            /*Запомним очередную цифру чисел*/
            int x = (int) a.charAt(i) - (int) '0';
            int y = (int) b.charAt(i) - (int) '0';

            /*Посчитаем соответствующий разряд результата*/
            int z = (x + y + ostatok) % 10;
            ostatok = (x + y + ostatok) / 10;

            /*Добавим разряд в дек*/
            q.add(z); /*Добавляет в конец дека*/
        }

        /*Если остаток (перенос на новый разряд) не равен 0, добавим этот остаток в дек*/
        while (ostatok != 0) {
            q.add(ostatok % 10); /*Добавляет в конец дека*/
            ostatok /= 10;
        }

        /*Переменная - результат суммы двух чисел*/
        String ans = "";

        /*Пока дек не пустой*/
        while (!q.isEmpty()) {
            /*Мы возбмем последнюю цифру дека и удалим ее из него*/
            int x = q.pollLast();
            /*Добавим полученную цифру в конец результата*/
            ans += x;
        }
        System.out.println(a + " + " + b + " = " + ans);
    }

}
